/*============================================================================================
    
    ------------------------------
    -*- [Menu] ExtraItems      -*-
    ------------------------------
    
    Описание: 
        Плагин создаёт главное меню сервера, в котором размещаются основные пункты.
        Плагин имеет натив для получения ID меню, чтобы использовать его для дальнейшего
        добавления пунктов меню.
        
        Это позволяет добавить пункты в меню нативно, без привязки меню в коде.
        
============================================================================================*/

#include <amxmodx>
#include <cstrike>
#include <fakemeta>
#include <dynamic_menu>
#include <simple_rbac>
#include <zp50_ammopacks>
#include <zp50_gamemodes>
#include <hamsandwich>

/*================================= Информация о плагине ===================================*/
#define PLUG_CREATOR            "Boec[SpecOPs]"
#define PLUG_VERSION            "1.0"
#define PLUG_OBJNAME            "Revive"

/*================== Первичная инициализация и завершение работы плагина ===================*/
#define AMMO_REQ 10

new group, menu, item, g_GameModeStarted
new cvar_deathmatch

public plugin_init() {
    register_plugin(PLUG_OBJNAME, PLUG_VERSION, PLUG_CREATOR);
    
    cvar_deathmatch = register_cvar("zp_deathmatch", "0")
}

public rbac_groups_register()
{
    
    // Регистрируем группу и получаем её идентификатор
    group = rbac_group_add(
        gs_name, "canRevive",
        gs_alias, "canRevive",
        gs_tag, "",
        gs_flags, 0
    );
}

public menu_register() {
    menu = cs_dmenu_create(
        SMenu,
        sm_header, "\rДислоцироваться в виде:"
    )
}

// Событие инициализации меню
public item_register() {
    cs_dmenu_additem(cs_dmenu("MainMenu"), 
        cs_dmenu_create(
            SMenuItem, 
            smi_tag, "Menu", 
            smi_name, "Дислоцироваться...", 
            smi_access, "hook__access_revive",
            smi_menu, menu
        )
    )
    
    item = cs_dmenu_additem(menu, 
        cs_dmenu_create(
            SMenuItem, 
            smi_tag, "CMD", 
            smi_name, "Человека", 
            smi_select, "hook__ashuman"
        )
    )
    cs_dmenu_additem(menu, 
        cs_dmenu_create(
            SMenuItem, 
            smi_tag, "CMD", 
            smi_name, "Зомби", 
            smi_select, "hook__aszombie"
        )
    )
    
    cs_dmenu_additem(cs_dmenu("MainMenu"), 
        cs_dmenu_create(
            SMenuItem, 
            smi_tag, "CMD", 
            smi_name, "В игру", 
            smi_select, "hook__join", 
            smi_access, "hook__access_join"
        )
    )
    
    cs_dmenu_additem(cs_dmenu("MainMenu"), 
        cs_dmenu_create(
            SMenuItem, 
            smi_tag, "CMD", 
            smi_name, "В наблюдатели", 
            smi_select, "hook__spectator", 
            smi_access, "hook__access_spectator"
        )
    )
}

public hook__aszombie(playerID, itemID) {
    zp_core_respawn_as_zombie(playerID, true)
    ExecuteHamB(Ham_CS_RoundRespawn, playerID)
}

public hook__ashuman(playerID, itemID) {
    if(!rbac_member_of(playerID, group)) {
        zp_ammopacks_set(playerID, zp_ammopacks_get(playerID)-AMMO_REQ)
    }
    ExecuteHamB(Ham_CS_RoundRespawn, playerID)
}

public zp_fw_gamemodes_start() {
    g_GameModeStarted = true
}

public zp_fw_gamemodes_end()
{
    g_GameModeStarted = false
}

public hook__access_ashuman(playerID, itemID) {
    if (zp_ammopacks_get(playerID) < AMMO_REQ || !g_GameModeStarted || get_pcvar_num(cvar_deathmatch) == 2 || (get_pcvar_num(cvar_deathmatch) == 3 && random_num(0, 1)) || (get_pcvar_num(cvar_deathmatch) == 4 && zp_core_get_zombie_count() < GetAliveCount()/2))
    {
        return if_noaccess
    }
    
    new snum[64]
    num_to_str(AMMO_REQ, snum, 63)
    format(snum, 63, "%s \w%s", "Человека", snum)
    if(rbac_member_of(playerID, group)) {
        cs_dmenu_set(SMenuItem, item, smi_name, "Человека")
    } else {
        cs_dmenu_set(SMenuItem, item, smi_name, snum)
    }
    
    return 0
}

public hook__access_revive(playerID, itemID) {
    if (is_user_alive(playerID))
        return if_noaccess
    if(cs_get_user_team(playerID) == CS_TEAM_SPECTATOR)
        return if_noaccess
    if(cs_get_user_team(playerID) == CS_TEAM_UNASSIGNED)
        return if_noaccess
    return 0
}

public hook__join(pID, iID) {
    set_pdata_int(pID, 125, get_pdata_int(pID, 125, 5) & ~(1<<8), 5)
    engclient_cmd( pID, "jointeam", "2" );

    new iClass[1];
    iClass[0] = random_num( '1', '4' );
    engclient_cmd(pID, "joinclass", iClass )
}

public hook__access_join(playerID, itemID) {
    if (is_user_alive(playerID))
        return if_noaccess
    if(cs_get_user_team(playerID) != CS_TEAM_SPECTATOR && cs_get_user_team(playerID) != CS_TEAM_UNASSIGNED)
        return if_noaccess
    return 0
}

public hook__spectator(pID, iID) {
    static msgid = 0;
    
    if (is_user_alive(pID)){
        new msgblock;
        if (!msgid)
        {
            msgid = get_user_msgid("DeathMsg");
        }
        msgblock = get_msg_block(msgid);
        set_msg_block(msgid, BLOCK_ONCE);    
        user_kill(pID, 0);
        set_msg_block(msgid, msgblock);
    }
    cs_set_user_team(pID, CS_TEAM_SPECTATOR)
}

public hook__access_spectator(playerID, itemID) {
    if(cs_get_user_team(playerID) == CS_TEAM_SPECTATOR)
        return if_noaccess
        
    if(!rbac_member_of(playerID, group))
        return if_noaccess
    
    return 0
}



// Get Alive Count -returns alive players number-
GetAliveCount()
{
    static maxplayers = 0
    if(!maxplayers) maxplayers = get_maxplayers()
    new iAlive, id

    for (id = 1; id <= maxplayers; id++)
    {
        if (is_user_alive(id))
            iAlive++
    }

    return iAlive;
}
